require 'jekyll_pages_api'
require 'safe_yaml'

module JekyllPagesApiSearch
  # This is a stand-in for a normal Jekyll::Site used only by the
  # standalone.rb module in this directory, since the full Jekyll::Site would be
  # too complex for this purpose.
  class Site
    attr_reader :source, :dest, :config, :baseurl
    attr_accessor :pages

    def initialize(basedir, config)
      @source = basedir
      @dest = basedir
      @config = SafeYAML.load_file(config, :safe => true)
      @baseurl = @config['baseurl'] || '/'
      @pages = []
    end

    # Needed by Jekyll::Page.initialize().
    def in_source_dir(*paths)
      paths
    end

    # Needed by Jekyll::Page.initialize().
    def in_theme_dir(*paths)
      nil
    end

    # Adds an existing pages.json file (generated by jekyll_pages_api) to
    # this site's `pages` collection.
    def load_pages_json(pages_json_path)
      basename = File.basename pages_json_path
      rel_dir = File.dirname pages_json_path
      rel_dir = rel_dir[self.source.size..rel_dir.size]
      page = ::JekyllPagesApi::PageWithoutAFile.new(
        self, self.source, rel_dir, basename)
      page.output = File.read(pages_json_path)
      self.pages << page
    end
  end
end
